<?php
declare(strict_types=1);

namespace FiloBlu\Refilo\Plugins\Model\ResourceModel\Db;

use Magento\Store\Model\StoreManagerInterface;

/**
 * Class GetAmountIdsByProduct
 * @see \Magento\GiftCard\Model\ResourceModel\Db\GetAmountIdsByProduct
 * @package FiloBlu\Refilo\Plugins\ResourceModel\Db
 */
class GetAmountIdsByProduct
{
    /**
     * @var StoreManagerInterface
     */
    private $storeManager;

    /**
     * GetAmountIdsByProduct constructor.
     * @param StoreManagerInterface $storeManager
     */
    public function __construct(StoreManagerInterface $storeManager)
    {

        $this->storeManager = $storeManager;
    }

    /**
     * @see \Magento\GiftCard\Model\ResourceModel\Db\GetAmountIdsByProduct::execute
     */
    public function beforeExecute($subject, $linkField, $productId, $websiteId = null)
    {
        if ($websiteId !== null) {
            return null;
        }

        $store = $this->storeManager->getStore();

        if (!$store) {
            return null;
        }

        return [$linkField, $productId, $store->getWebsiteId()];
    }
}
